use 5.010000;
use ExtUtils::MakeMaker;
# See lib/ExtUtils/MakeMaker.pm for details of how to influence
# the contents of the Makefile that is written.

$CCFLAGS_DARWIN = '-arch x86_64 -g -pipe -fno-common -DPERL_DARWIN -fno-strict-aliasing -I/usr/local/include';
$LDDLFLAGS_DARWIN = '-arch x86_64 -m64 -bundle -undefined dynamic_lookup -L/usr/local/lib';

my %params = (
    NAME              => 'PinSketch',
    VERSION_FROM      => 'lib/PinSketch.pm', # finds $VERSION
    PREREQ_PM         => {}, # e.g., Module::Name => 1.1
    ($] >= 5.005 ?     ## Add these new keywords supported since 5.005
      (ABSTRACT_FROM  => 'lib/PinSketch.pm', # retrieve abstract from module
       AUTHOR         => 'Gergely Acs <acs@crysys.hu>') : ()),
    LIBS              => ['-lntl'], # e.g., '-lm'
    DEFINE            => '', # e.g., '-DHAVE_SOMETHING'
    INC               => '-I.', # e.g., '-I. -I/usr/include/other'
    CC               => 'g++', # e.g., '-I. -I/usr/include/other'
    XSOPT             => '-C++',
    TYPEMAPS          => ['perlobject.map' ],
    'MYEXTLIB' => 'libpinsketch/libpinsketch$(LIB_EXT)',
	# Un-comment this if you add C files to link with later:
    # OBJECT            => '$(O_FILES)', # link all the C files too
    );

print "OS type: $^O\n"; 
if ($^O =~ /darwin/)
{
	print "CCFLAGS = $CCFLAGS_DARWIN\n";
	print "LDDLFLAGS = $LDDLFLAGS_DARWIN\n";
	$params{CCFLAGS} = $CCFLAGS_DARWIN;
	$params{LDDLFLAGS} = $LDDLFLAGS_DARWIN;
}

WriteMakefile(%params);

if  (eval {require ExtUtils::Constant; 1}) {
  # If you edit these definitions to change the constants used by this module,
  # you will need to use the generated const-c.inc and const-xs.inc
  # files to replace their "fallback" counterparts before distributing your
  # changes.
  my @names = (qw());
  ExtUtils::Constant::WriteConstants(
                                     NAME         => 'PinSketch',
                                     NAMES        => \@names,
                                     DEFAULT_TYPE => 'IV',
                                     C_FILE       => 'const-c.inc',
                                     XS_FILE      => 'const-xs.inc',
                                  );

}
else {
  use File::Copy;
  use File::Spec;
  foreach my $file ('const-c.inc', 'const-xs.inc') {
    my $fallback = File::Spec->catfile('fallback', $file);
    copy ($fallback, $file) or die "Can't copy $fallback to $file: $!";
  }
}

sub MY::postamble {
'
$(MYEXTLIB): libpinsketch/Makefile
	cd libpinsketch && $(MAKE) $(PASSTHRU)
';
}

