
#include <./libpinsketch/pinsketch.h>


#ifdef __cplusplus
extern "C" {
#endif
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#include "ppport.h"
#ifdef __cplusplus
}
#endif

#include <sstream>


#include "const-c.inc"

MODULE = PinSketch		PACKAGE = PinSketch		

INCLUDE: const-xs.inc

PinSketch*
PinSketch::new(int t, int m)

void
PinSketch::DESTROY()

SV*
PinSketch::GetSketch(set_str)
		SV*	set_str
	INIT:
		std::ostringstream out;
		NTL::ZZ r;
		NTL::vec_GF2E set;
		int len;

		if ((!SvROK(set_str))
			|| (SvTYPE(SvRV(set_str)) != SVt_PVAV)
			|| ((len = av_len((AV *)SvRV(set_str))) < 0))
		{
			XSRETURN_UNDEF;
		}

		set.SetLength(len + 1);
	CODE:
		for (long i = 0; i < len + 1; i++)
		{
			r = NTL::to_ZZ(SvPV_nolen(*av_fetch((AV *)SvRV(set_str), i, 0)));
			THIS->NumToBinElem(set[i], r); 
		}

		THIS->GetSS(set, out);

		RETVAL = newSVpv(out.str().c_str(), out.str().length());
	OUTPUT:
		RETVAL

SV*
PinSketch::GetDiff(ss1, set2_str, outSet)
		SV*	ss1
		SV*	set2_str
		SV*	outSet
	INIT:
		std::stringstream in, out;
		NTL::vec_GF2E ss2;
		AV * result;
		NTL::ZZ r;
		NTL::vec_GF2E set2;
		long len;

		if ((!SvROK(set2_str))
			|| (SvTYPE(SvRV(set2_str)) != SVt_PVAV)
			|| ((len = av_len((AV *)SvRV(set2_str))) < 0))
		{
			XSRETURN_UNDEF;
		}

		if (!SvROK(outSet)
			|| SvTYPE(SvRV(outSet)) != SVt_PVAV)
		{
			XSRETURN_UNDEF;
		}

		result = (AV*) SvRV(outSet);

		set2.SetLength(len + 1);

	CODE:
		for (long i = 0; i < len + 1; i++)
		{
			r = NTL::to_ZZ(SvPV_nolen(*av_fetch((AV *)SvRV(set2_str), i, 0)));
			THIS->NumToBinElem(set2[i], r);
		}

		THIS->GetSS(set2, ss2);

		in << SvPV_nolen(ss1);

		long ret = THIS->GetDiff(in, ss2, out);

		for (long i = 0; i < ret; i++)
		{
    			std::string tmp; 
    			out >> tmp;
    			av_push(result, newSVpv(tmp.c_str(), tmp.length()));
		}

		RETVAL = newSViv(ret);
	OUTPUT:
		RETVAL

SV*
PinSketch::GetDiffFromSketches(ss1, ss2, outSet)
		SV*	ss1
		SV*	ss2
		SV*	outSet
	INIT:
		std::stringstream in1, in2, out;
		AV * result;

		if (!SvROK(outSet)
			|| SvTYPE(SvRV(outSet)) != SVt_PVAV)
		{
			XSRETURN_UNDEF;
		}

		result = (AV*) SvRV(outSet);

	CODE:
		in1 << SvPV_nolen(ss1);
		in2 << SvPV_nolen(ss2);

		long ret = THIS->GetDiffFromSketches(in1, in2, out);

		for (long i = 0; i < ret; i++)
		{
    			long tmp; 
    			out >> tmp;
    			av_push(result, newSViv(tmp));
		}

		RETVAL = newSViv(ret);
	OUTPUT:
		RETVAL



