use ExtUtils::MakeMaker;
use Config;
use POSIX;

# Check if this is a 64 bit machine
my $CCFLAGS = '';
my $machine = (POSIX::uname())[4];
if ($machine =~ /64/) {
        $CCFLAGS = '-fPIC';
}

$CCFLAGS_DARWIN = '-arch x86_64 -g -pipe -fno-common -DPERL_DARWIN -fno-strict-aliasing -I/usr/local/include';

my %params = (
	NAME         => 'libpinsketch',
	SKIP         => [qw(all static static_lib dynamic dynamic_lib)],
	C	     => ['pinsketch.cpp'],
	H	     => ['pinsketch.h'],
	OBJECT       => 'pinsketch.o',
	MYEXTLIB     => 'libpinsketch$(LIB_EXT)',
	clean        => {'FILES' => 'libpinsketch$(LIBEEXT) $(OBJECT)'},
);


print "OS type: $^O\n"; 
if ($^O =~ /darwin/)
{
	print "CCFLAGS = $CCFLAGS_DARWIN\n";
	$params{CCFLAGS} = $CCFLAGS_DARWIN;
}

WriteMakefile(%params);

sub MY::top_targets {
'
all :: static

pure_all :: static

static :: $(OBJECT) libpinsketch$(LIB_EXT)

pinsketch.o :
	$(CXX) -c $(INC) $(DEFINE_VERSION) $(XS_DEFINE_VERSION) $(CCFLAGS) -o pinsketch.o pinsketch.cpp

libpinsketch$(LIB_EXT): $(O_FILES)
	$(AR) cr libpinsketch$(LIB_EXT) $(OBJECT)
	$(RANLIB) libpinsketch$(LIB_EXT)
';
}
